﻿# 阅读实验源代码
**main.c文件**   
在main函数中首先创建了一般树，然后调用PreOrder函数对一般树进行先序遍历操作，并将产生的先序序列保存在全局变量g_string中。   
在main函数的后面，定义了一般树的先序遍历函数PreOrder， 此函数的函数体还不完整，留给读者完成。   
**CSTree.h文件**   
定义了与一般树相关的数据结构并声明了相关的操作函数和全局变量。注意，此头文件中还包含了栈模块的头文件Stack.h。   
**Stack.h文件**   
定义了与栈相关的数据结构并声明了相关的操作函数。   
**Stack.c文件**    
定义了与栈相关的操作函数。   
# 在演示模式下调试项目
**按照下面的步骤调试项目：**
1.	按F7生成项目。
2.	在演示模式下，按F5启动调试项目。程序会在观察点函数的开始位置中断。
3.	重复按F5，直到调试过程结束。

在调试的过程中，每执行“演示流程”窗口中的一行后，仔细观察“可视化数据”窗口内容所发生的变化，理解一般树先序遍历的执行过程。“可视化数据”窗口显示的数据信息（如下图所示），包括：
-	先序遍历一般树时，树节点按照其被访问的先后顺序所组成的先序遍历字符串。
-	一般树的详细信息。   
a)	一般树节点的值和地址。   
b)	已访问过的结点的底色为灰色，并且在该结点中，用白色的字体标出了访问过的序号。   
c)	在栈中的结点的底色为绿色。   
d)	用红色带箭头的虚线表示出了访问节点的轨迹。   
e)	游标指向了当前的节点。   
-	先序遍历一般树时使用的栈，栈的填充色为绿色。包括了一般树节点的地址、值（空地址的值会被忽略）。   

![一般树的遍历](./img/14.png)

# 编写源代码并通过验证
**按照下面的步骤继续实验：**
1.	为PreOrder函数编写源代码，要求利用栈实现非递归的先序遍历算法，并生成先序序列字符串。注意，尽量使用已定义的局部变量。
2.	按F7生成项目。如果生成失败，根据“输出”窗口中的提示信息修改源代码中的语法错误。
3.	按Alt+F5启动验证。如果验证失败，可以使用“输出”窗口中的“比较”功能，或者在“非演示模式”下按F5启动调试后重复按F10单步调试读者编写的源代码，从而定位错误的位置，然
后回到步骤1。
提示：在验证过程中，主要是检测先序序列字符串生成的是否正确，所以，为了顺利通过验证，请读者在遍历一般树的同时一定要在全局变量g_string中生成先序序列字符串。

# 教师参考答案
请教师用户首先访问[教师项目群组](https://www.codecode.net/engintime/ds-lab/teachers-packet),申请权限并审核通过后，再[domain relative url](engintime/ds-lab/teachers-packet/Lab014.git)访问本项目的参考答案